"""
Django settings for validator project.

Generated by 'django-admin startproject' using Django 4.2.4.

For more information on this file, see
https://docs.djangoproject.com/en/4.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.2/ref/settings/
"""

from pathlib import Path
import os, sys

local = 'runserver makemigrations createsuperuser migrate changepassword'

RUNNING_DEVSERVER = (len(sys.argv) > 1 and sys.argv[1] in local.split())

def getsettings():
    ret = {}
    with open("/etc/validator/settings.ini") as settingsfile:
        for line in settingsfile.readlines():
            key, val = (item.strip() for item in line.split('=', 1))
            ret[key] = val
    return ret

if not RUNNING_DEVSERVER:
    settings = getsettings()

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
if RUNNING_DEVSERVER:
    SECRET_KEY = 'django-insecure-%os!7$!7w95^k440jb)wao4lwji96yf59k@pfs&!p)-rxu8m!v'
else:
    SECRET_KEY = settings['validator_SECRET_KEY']

if RUNNING_DEVSERVER:
    TEST_FILE = './validator/test.txt'
else:
    TEST_FILE = f"/home/{settings['user']}/apps/validator/validator/test.txt"


# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = RUNNING_DEVSERVER

if RUNNING_DEVSERVER:
    ALLOWED_HOSTS = []
else:
    hostname = settings['validator_HOSTNAME']
    ALLOWED_HOSTS = ['www.' + hostname, hostname, 'localhost', '127.0.0.1']



# Application definition

INSTALLED_APPS = [
    'validator.apps.ValidatorConfig',
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'config.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'config.wsgi.application'


# Database
# https://docs.djangoproject.com/en/4.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': BASE_DIR / 'db.sqlite3',
    }
}


# Password validation
# https://docs.djangoproject.com/en/4.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.2/howto/static-files/

STATIC_URL = '/static/'
STATIC_URL = 'static/'
if DEBUG:
    STATICFILES_DIRS = [BASE_DIR / "validator/static"]
else:
    STATIC_ROOT = BASE_DIR / "validator/static"



# Default primary key field type
# https://docs.djangoproject.com/en/4.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

